> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pdf.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Merge Various Document Type

> Merge PDF from two or more PDF, DOC, XLS, images, even ZIP with documents and images into a new PDF.

## `POST /v1/pdf/merge2`

<Warning>We do not support images in the HEIC format (Apple’s image format) or the WEBP format.</Warning>

<Warning>The total combined size of all input file URls must not exceed **2 GB**. Requests that exceed this limit will not be processed. </Warning>

This endpoint is similar to [/pdf/merge](/api-reference/merge/pdf) but it also supports `zip`, `doc`, `docx`, `xls`, `xlsx`, `rtf`, `txt`, `png`, `jpg` files as source.

We recommended to use this endpoint in `async: true` mode because it may need to convert source documents to PDF.

This endpoint also consumes more credits because of the internal conversions.

## Attributes

<Note>Attributes are case-sensitive and should be inside JSON for POST request. for example: `{ "url": "https://example.com/file1.pdf" }`</Note>

| Attribute                     | Type    | Required | Default | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| ----------------------------- | ------- | -------- | ------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `url`                         | string  | *Yes*    | -       | URLs to the source file [`url` attribute](/api-reference/url-input-and-request-limits#supported-file-sources). If you use multiple URLs, please separate them with a `,`                                                                                                                                                                                                                                                                                                                |
| `callback`                    | string  | *No*     | -       | The callback URL (or Webhook) used to receive the POST data. see [Webhooks & Callbacks](/api-reference/webhooks). This is only applicable when `async` is set to `true`.                                                                                                                                                                                                                                                                                                                |
| `httpusername`                | string  | *No*     | -       | HTTP auth user name if required to access source URL.                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| `httppassword`                | string  | *No*     | -       | HTTP auth password if required to access source URL.                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| `async`                       | boolean | *No*     | `false` | Set `async` to `true` for long processes to run in the background, API will then return a `jobId` which you can use with the [Background Job Check endpoint](/api-reference/job-check). Also see [Webhooks & Callbacks](/api-reference/webhooks)                                                                                                                                                                                                                                        |
| `name`                        | string  | *No*     | -       | File name for the generated output, the input must be in string format.                                                                                                                                                                                                                                                                                                                                                                                                                 |
| `expiration`                  | integer | *No*     | `60`    | Set the expiration time for the output link in minutes. After this specified duration, any generated output file(s) will be automatically deleted from [PDF.co Temporary Files Storage](/api-reference/file-upload/overview). The maximum duration for link expiration varies based on your current subscription plan. To store permanent input files (e.g. re-usable images, pdf templates, documents) consider using [PDF.co Built-In Files Storage](https://app.pdf.co/tools/files). |
| `profiles`                    | object  | *No*     | -       | See [Profiles](/api-reference/profiles) for more information.                                                                                                                                                                                                                                                                                                                                                                                                                           |
|     `outputDataFormat`        | string  | *No*     | -       | If you require your output as `base64` format, set this to `base64`                                                                                                                                                                                                                                                                                                                                                                                                                     |
|     `DataEncryptionAlgorithm` | string  | *No*     | -       | Controls the encryption algorithm used for data encryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information. The available algorithms are: `AES128`, `AES192`, `AES256`.                                                                                                                                                                                                                                                               |
|     `DataEncryptionKey`       | string  | *No*     | -       | Controls the encryption key used for data encryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information.                                                                                                                                                                                                                                                                                                                                 |
|     `DataEncryptionIV`        | string  | *No*     | -       | Controls the encryption IV used for data encryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information.                                                                                                                                                                                                                                                                                                                                  |
|     `DataDecryptionAlgorithm` | string  | *No*     | -       | Controls the decryption algorithm used for data decryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information. The available algorithms are: `AES128`, `AES192`, `AES256`.                                                                                                                                                                                                                                                               |
|     `DataDecryptionKey`       | string  | *No*     | -       | Controls the decryption key used for data decryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information.                                                                                                                                                                                                                                                                                                                                 |
|     `DataDecryptionIV`        | string  | *No*     | -       | Controls the decryption IV used for data decryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information.                                                                                                                                                                                                                                                                                                                                  |

## Query parameters

*No query parameters accepted.*

## Responses

| Parameter             | Type    | Description                                                                                                                  |
| --------------------- | ------- | ---------------------------------------------------------------------------------------------------------------------------- |
| `url`                 | string  | Direct URL to the final PDF file stored in S3.                                                                               |
| `outputLinkValidTill` | string  | Timestamp indicating when the output link will expire                                                                        |
| `pageCount`           | integer | Number of pages in the PDF document.                                                                                         |
| `error`               | boolean | Indicates whether an error occurred (`false` means success)                                                                  |
| `status`              | string  | Status code of the request (200, 404, 500, etc.). For more information, see [Response Codes](/api-reference/response-codes). |
| `name`                | string  | Name of the output file                                                                                                      |
| `credits`             | integer | Number of credits consumed by the request                                                                                    |
| `remainingCredits`    | integer | Number of credits remaining in the account                                                                                   |
| `duration`            | integer | Time taken for the operation in milliseconds                                                                                 |

## `Example` Payload

<Note>To see the request size limits, please refer to the [Request Size Limits](/api-reference/url-input-and-request-limits#pdf-co-request-size).</Note>

```json theme={null}
{
  "url": "https://pdfco-test-files.s3.us-west-2.amazonaws.com/pdf-merge/sample1.pdf,https://pdfco-test-files.s3.us-west-2.amazonaws.com/other/Input.xls, https://pdfco-test-files.s3.us-west-2.amazonaws.com/pdf-merge/images-and-documents.zip",
  "async": false
}
```

## `Example` Response

<Note>To see the main response codes, please refer to the [Response Codes](/api-reference/response-codes) page.</Note>

```json theme={null}
{
  "url": "https://pdf-temp-files.s3.amazonaws.com/3ec287356c0b4e02b5231354f94086f2/result.pdf",
  "error": false,
  "status": 200,
  "name": "result.pdf",
  "remainingCredits": 98465
}
```

<Note>
  **Inconsistent URL Encoding in cURL Output:** When using cURL to make API requests, the output JSON may show URL characters encoded as Unicode escape sequences. For example, the ampersand character (`&`) may appear as `\u0026` in the cURL output. This is normal JSON encoding behavior and does not affect the validity of the URL. The URL will function correctly when used, as JSON parsers automatically decode these escape sequences. If you're parsing the response programmatically, your JSON parser will handle this conversion automatically.
</Note>

## Code Samples

<Tabs>
  <Tab title="CURL">
    ```bash theme={null}
    curl --location --request POST 'https://api.pdf.co/v1/pdf/merge2' \
    --header 'x-api-key: *******************' \
    --header 'Content-Type: application/json' \
    --data-raw '{
    "url": "https://pdfco-test-files.s3.us-west-2.amazonaws.com/pdf-merge/sample1.pdf,https://pdfco-test-files.s3.us-west-2.amazonaws.com/other/Input.xls, https://pdfco-test-files.s3.us-west-2.amazonaws.com/pdf-merge/images-and-documents.zip",
    "async": false
    }'
    ```
  </Tab>

  <Tab title="JavaScript/Node.js">
    ```javascript theme={null}
    var https = require("https");
    var path = require("path");
    var fs = require("fs");

    // The authentication key (API Key).
    // Get your own by registering at https://app.pdf.co
    const API_KEY = "***********************************";

    // Direct URLs of files to merge. Supports documents, spreadsheets, images as sources.
    // You can also upload your own file into PDF.co and use it as url. Check "Upload File" samples for code snippets: https://github.com/pdfdotco/pdf-co-api-samples/tree/master/File%20Upload/
    const SourceFiles = [
      "https://pdfco-test-files.s3.us-west-2.amazonaws.com/pdf-merge/sample1.pdf",
      "https://pdfco-test-files.s3.us-west-2.amazonaws.com/other/Input.xls",
      "https://pdfco-test-files.s3.us-west-2.amazonaws.com/doc-to-pdf/sample.docx",
      "https://pdfco-test-files.s3.us-west-2.amazonaws.com/image-to-pdf/image1.png",
      "https://pdfco-test-files.s3.us-west-2.amazonaws.com/image-to-pdf/image2.jpg"
    ];
    // Destination PDF file name
    const DestinationFile = "./result.pdf";

    // Prepare request to `Merge Documents` API endpoint
    var queryPath = `/v1/pdf/merge2`;

    // JSON payload for api request
    var jsonPayload = JSON.stringify({
      name: path.basename(DestinationFile), url: SourceFiles.join(","), async: true
    });

    var reqOptions = {
      host: "api.pdf.co",
      method: "POST",
      path: queryPath,
      headers: {
          "x-api-key": API_KEY,
          "Content-Type": "application/json",
          "Content-Length": Buffer.byteLength(jsonPayload, 'utf8')
      }
    };
    // Send request
    var postRequest = https.request(reqOptions, (response) => {
      response.on("data", (d) => {
          // Parse JSON response
          var data = JSON.parse(d);
          if (data.error == false) {
              console.log(`Job #${data.jobId} has been created!`);
              checkIfJobIsCompleted(data.jobId, data.url);
          }
          else {
              // Service reported error
              console.log(data.message);
          }
      });
    }).on("error", (e) => {
      // Request error
      console.log(e);
    });

    // Write request data
    postRequest.write(jsonPayload);
    postRequest.end();

    function checkIfJobIsCompleted(jobId, resultFileUrl) {
      let queryPath = `/v1/job/check`;

      // JSON payload for api request
      let jsonPayload = JSON.stringify({
          jobid: jobId
      });

      let reqOptions = {
          host: "api.pdf.co",
          path: queryPath,
          method: "POST",
          headers: {
              "x-api-key": API_KEY,
              "Content-Type": "application/json",
              "Content-Length": Buffer.byteLength(jsonPayload, 'utf8')
          }
      };

      // Send request
      var postRequest = https.request(reqOptions, (response) => {
          response.on("data", (d) => {
              response.setEncoding("utf8");

              // Parse JSON response
              let data = JSON.parse(d);
              console.log(`Checking Job #${jobId}, Status: ${data.status}, Time: ${new Date().toLocaleString()}`);

              if (data.status == "working") {
                  // Check again after 3 seconds
                  setTimeout(function () { checkIfJobIsCompleted(jobId, resultFileUrl); }, 3000);
              }
              else if (data.status == "success") {
                  // Download PDF file
                  var file = fs.createWriteStream(DestinationFile);
                  https.get(resultFileUrl, (response2) => {
                      response2.pipe(file)
                          .on("close", () => {
                              console.log(`Generated PDF file saved as "${DestinationFile}" file.`);
                          });
                  });
              }
              else {
                  console.log(`Operation ended with status: "${data.status}".`);
              }
          })
      });

      // Write request data
      postRequest.write(jsonPayload);
      postRequest.end();
    }
    ```
  </Tab>

  <Tab title="Python">
    ```python theme={null}
    import os
    import requests # pip install requests
    import time
    import datetime

    # The authentication key (API Key).
    # Get your own by registering at https://app.pdf.co
    API_KEY = "******************************************"

    # Base URL for PDF.co Web API requests
    BASE_URL = "https://api.pdf.co/v1"

    # Source Document files. Supports documents, spreadsheets, images as sources.
    SourceFile_1 = ".\\sample1.pdf"
    SourceFile_2 = ".\\sample.docx"

    # Destination PDF file name
    DestinationFile = ".\\result.pdf"

    # (!) Make asynchronous job
    Async = True


    def main(args = None):
      UploadedFileUrl_1 = uploadFile(SourceFile_1)
      UploadedFileUrl_2 = uploadFile(SourceFile_2)

      if (UploadedFileUrl_1 != None and UploadedFileUrl_2!= None):
          uploadedFileUrls = "{},{}".format(UploadedFileUrl_1, UploadedFileUrl_2)
          mergeFiles(uploadedFileUrls, DestinationFile)


    def mergeFiles(uploadedFileUrls, destinationFile):
      """Perform Merge using PDF.co Web API"""

      # Prepare requests params as JSON
      # See documentation: https://docs.pdf.co
      parameters = {}
      parameters["async"] = Async
      parameters["name"] = os.path.basename(destinationFile)
      parameters["url"] = uploadedFileUrls

      # Prepare URL for 'Merge Document' API request
      url = "{}/pdf/merge2".format(BASE_URL)

      # Execute request and get response as JSON
      response = requests.post(url, data=parameters, headers={ "x-api-key": API_KEY })
      if (response.status_code == 200):
          json = response.json()

          if json["error"] == False:
              # Asynchronous job ID
              jobId = json["jobId"]
              #  URL of the result file
              resultFileUrl = json["url"]
              
              # Check the job status in a loop. 
              # If you don't want to pause the main thread you can rework the code 
              # to use a separate thread for the status checking and completion.
              while True:
                  status = checkJobStatus(jobId) # Possible statuses: "working", "failed", "aborted", "success".
                  
                  # Display timestamp and status (for demo purposes)
                  print(datetime.datetime.now().strftime("%H:%M.%S") + ": " + status)
                  
                  if status == "success":
                      # Download result file
                      r = requests.get(resultFileUrl, stream=True)
                      if (r.status_code == 200):
                          with open(destinationFile, 'wb') as file:
                              for chunk in r:
                                  file.write(chunk)
                          print(f"Result file saved as \"{destinationFile}\" file.")
                      else:
                          print(f"Request error: {response.status_code} {response.reason}")
                      break
                  elif status == "working":
                      # Pause for a few seconds
                      time.sleep(3)
                  else:
                      print(status)
                      break
          else:
              # Show service reported error
              print(json["message"])
      else:
          print(f"Request error: {response.status_code} {response.reason}")


    def checkJobStatus(jobId):
      """Checks server job status"""

      url = f"{BASE_URL}/job/check?jobid={jobId}"
      
      response = requests.get(url, headers={ "x-api-key": API_KEY })
      if (response.status_code == 200):
          json = response.json()
          return json["status"]
      else:
          print(f"Request error: {response.status_code} {response.reason}")

      return None


    def uploadFile(fileName):
      """Uploads file to the cloud"""
      
      # 1. RETRIEVE PRESIGNED URL TO UPLOAD FILE.

      # Prepare URL for 'Get Presigned URL' API request
      url = "{}/file/upload/get-presigned-url?contenttype=application/octet-stream&name={}".format(
          BASE_URL, os.path.basename(fileName))
      
      # Execute request and get response as JSON
      response = requests.get(url, headers={ "x-api-key": API_KEY })
      if (response.status_code == 200):
          json = response.json()
          
          if json["error"] == False:
              # URL to use for file upload
              uploadUrl = json["presignedUrl"]
              # URL for future reference
              uploadedFileUrl = json["url"]

              # 2. UPLOAD FILE TO CLOUD.
              with open(fileName, 'rb') as file:
                  requests.put(uploadUrl, data=file, headers={ "x-api-key": API_KEY, "content-type": "application/octet-stream" })

              return uploadedFileUrl
          else:
              # Show service reported error
              print(json["message"])    
      else:
          print(f"Request error: {response.status_code} {response.reason}")

      return None


    if __name__ == '__main__':
      main()
    ```
  </Tab>

  <Tab title="C#">
    ```csharp theme={null}
    using System;
    using System.IO;
    using System.Net;
    using Newtonsoft.Json.Linq;
    using System.Threading;
    using System.Collections.Generic;
    using Newtonsoft.Json;


    // Cloud API asynchronous "Merge Document" job example. Supports documents, spreadsheets, images as sources.
    // Allows to avoid timeout errors when processing huge or scanned PDF documents.

    namespace PDFcoApiExample
    {
    class Program
    {
      // The authentication key (API Key).
      // Get your own by registering at https://app.pdf.co
      const String API_KEY = "***********************************";
      
      // Direct URLs of PDF files to merge. Supports documents, spreadsheets, images as sources.
      // You can also upload your own file into PDF.co and use it as url. Check "Upload File" samples for code snippets: https://github.com/pdfdotco/pdf-co-api-samples/tree/master/File%20Upload/						
      static string[] SourceFiles = {
            "https://pdfco-test-files.s3.us-west-2.amazonaws.com/pdf-merge/sample1.pdf",
            "https://pdfco-test-files.s3.us-west-2.amazonaws.com/other/Input.xls",
            "https://pdfco-test-files.s3.us-west-2.amazonaws.com/doc-to-pdf/sample.docx",
            "https://pdfco-test-files.s3.us-west-2.amazonaws.com/image-to-pdf/image1.png",
            "https://pdfco-test-files.s3.us-west-2.amazonaws.com/image-to-pdf/image2.jpg"
        };
      // Destination PDF file name
      const string DestinationFile = @".\result.pdf";
      // (!) Make asynchronous job
      const bool Async = true;


      static void Main(string[] args)
      {
        // Create standard .NET web client instance
        WebClient webClient = new WebClient();

        // Set API Key
        webClient.Headers.Add("x-api-key", API_KEY);

        // Prepare URL for `Merge PDF` API call
        string url = "https://api.pdf.co/v1/pdf/merge2";

        // Prepare requests params as JSON
        Dictionary<string, object> parameters = new Dictionary<string, object>();
        parameters.Add("name", Path.GetFileName(DestinationFile));
        parameters.Add("url", string.Join(",", SourceFiles));
        parameters.Add("async", Async);

        // Convert dictionary of params to JSON
        string jsonPayload = JsonConvert.SerializeObject(parameters);

        try
        {
          // Execute POST request with JSON payload
          string response = webClient.UploadString(url, jsonPayload);

          // Parse JSON response
          JObject json = JObject.Parse(response);

          if (json["error"].ToObject<bool>() == false)
          {
            // Asynchronous job ID
            string jobId = json["jobId"].ToString();
            // URL of generated PDF file that will available after the job completion
            string resultFileUrl = json["url"].ToString();

            // Check the job status in a loop. 
            // If you don't want to pause the main thread you can rework the code 
            // to use a separate thread for the status checking and completion.
            do
            {
              string status = CheckJobStatus(jobId); // Possible statuses: "working", "failed", "aborted", "success".

              // Display timestamp and status (for demo purposes)
              Console.WriteLine(DateTime.Now.ToLongTimeString() + ": " + status);

              if (status == "success")
              {
                // Download PDF file
                webClient.DownloadFile(resultFileUrl, DestinationFile);

                Console.WriteLine("Generated PDF file saved as \"{0}\" file.", DestinationFile);
                break;
              }
              else if (status == "working")
              {
                // Pause for a few seconds
                Thread.Sleep(3000);
              }
              else
              {
                Console.WriteLine(status);
                break;
              }
            }
            while (true);
          }
          else
          {
            Console.WriteLine(json["message"].ToString());
          }
        }
        catch (WebException e)
        {
          Console.WriteLine(e.ToString());
        }

        webClient.Dispose();


        Console.WriteLine();
        Console.WriteLine("Press any key...");
        Console.ReadKey();
      }

      static string CheckJobStatus(string jobId)
      {
        using (WebClient webClient = new WebClient())
        {
          // Set API Key
                  webClient.Headers.Add("x-api-key", API_KEY);
          
          string url = "https://api.pdf.co/v1/job/check?jobid=" + jobId;

          string response = webClient.DownloadString(url);
          JObject json = JObject.Parse(response);

          return Convert.ToString(json["status"]);
        }
      }
    }
    }
    ```
  </Tab>

  <Tab title="Java">
    ```java theme={null}
    package com.company;

    import com.google.gson.JsonObject;
    import com.google.gson.JsonParser;
    import okhttp3.*;

    import java.io.*;
    import java.net.*;
    import java.nio.file.Path;
    import java.nio.file.Paths;

    public class Main
    {
      // The authentication key (API Key).
      // Get your own by registering at https://app.pdf.co
      final static String API_KEY = "***********************************";

      // Direct URLs of input files to merge. Supports documents, spreadsheets, images as sources.
      // You can also upload your own file into PDF.co and use it as url. Check "Upload File" samples for code snippets: https://github.com/pdfdotco/pdf-co-api-samples/tree/master/File%20Upload/    
    final static String[] SourceFiles = {
          "https://pdfco-test-files.s3.us-west-2.amazonaws.com/pdf-merge/sample1.pdf",
          "https://pdfco-test-files.s3.us-west-2.amazonaws.com/doc-to-pdf/sample.docx"
      };
      // Destination PDF file name
      final static Path DestinationFile = Paths.get(".\\result.pdf");


      public static void main(String[] args) throws IOException
      {
          // Create HTTP client instance
          OkHttpClient webClient = new OkHttpClient();

          // Prepare URL for `Merge Document` API call
          String query = "https://api.pdf.co/v1/pdf/merge2";

          // Make correctly escaped (encoded) URL
          URL url = null;
          try
          {
              url = new URI(null, query, null).toURL();
          }
          catch (URISyntaxException e)
          {
              e.printStackTrace();
          }

          // Create JSON payload
      String jsonPayload = String.format("{\"name\": \"%s\", \"url\": \"%s\"}",
                  DestinationFile.getFileName(),
                  String.join(",", SourceFiles));

          // Prepare request body
          RequestBody body = RequestBody.create(MediaType.parse("application/json"), jsonPayload);
          
          // Prepare request
          Request request = new Request.Builder()
              .url(url)
              .addHeader("x-api-key", API_KEY) // (!) Set API Key
              .addHeader("Content-Type", "application/json")
              .post(body)
              .build();
          
          // Execute request
          Response response = webClient.newCall(request).execute();
          

          if (response.code() == 200)
          {
              // Parse JSON response
              JsonObject json = new JsonParser().parse(response.body().string()).getAsJsonObject();

              boolean error = json.get("error").getAsBoolean();
              if (!error)
              {
                  // Get URL of generated PDF file
                  String resultFileUrl = json.get("url").getAsString();

                  // Download PDF file
                  downloadFile(webClient, resultFileUrl, DestinationFile.toFile());

                  System.out.printf("Generated PDF file saved as \"%s\" file.", DestinationFile.toString());
              }
              else
              {
                  // Display service reported error
                  System.out.println(json.get("message").getAsString());
              }
          }
          else
          {
              // Display request error
              System.out.println(response.code() + " " + response.message());
          }
      }

      public static void downloadFile(OkHttpClient webClient, String url, File destinationFile) throws IOException
      {
          // Prepare request
          Request request = new Request.Builder()
                  .url(url)
                  .build();
          // Execute request
          Response response = webClient.newCall(request).execute();

          byte[] fileBytes = response.body().bytes();

          // Save downloaded bytes to file
          OutputStream output = new FileOutputStream(destinationFile);
          output.write(fileBytes);
          output.flush();
          output.close();

          response.close();
      }
    }
    ```
  </Tab>

  <Tab title="PHP">
    ```php theme={null}
    <!DOCTYPE html>
    <html lang="en">
    <head>
      <meta charset="UTF-8">
      <title>Cloud API asynchronous "PDF Merging 2" job example (allows to avoid timeout errors).</title>
    </head>
    <body>

    <?php

    // Cloud API asynchronous "PDF Merging" job example. Supports documents, spreadsheets, images as sources.
    // Allows to avoid timeout errors when processing huge or scanned PDF documents.


    // The authentication key (API Key).
    // Get your own by registering at https://app.pdf.co
    $apiKey = "****************************************";

    // Direct URLs of input files to merge. Check another example if you need to upload local files to the cloud.
    // You can also upload your own file into PDF.co and use it as url. Check "Upload File" samples for code snippets: https://github.com/pdfdotco/pdf-co-api-samples/tree/master/File%20Upload/
    $sourceFiles = array(
      "https://pdfco-test-files.s3.us-west-2.amazonaws.com/pdf-merge/sample1.pdf",
      "https://pdfco-test-files.s3.us-west-2.amazonaws.com/other/Input.xls",
      "https://pdfco-test-files.s3.us-west-2.amazonaws.com/doc-to-pdf/sample.docx",
      "https://pdfco-test-files.s3.us-west-2.amazonaws.com/image-to-pdf/image1.png",
      "https://pdfco-test-files.s3.us-west-2.amazonaws.com/image-to-pdf/image2.jpg"
    );


    // Prepare URL for `Merge PDF` API call. Supports documents, spreadsheets, images as sources.
    $url = "https://api.pdf.co/v1/pdf/merge2";

    // Prepare requests params
    $parameters = array();
    $parameters["name"] = "result.pdf";
    $parameters["url"] = join(",", $sourceFiles);
    $parameters["async"] = true; // (!) Make asynchronous job

    // Create Json payload
    $data = json_encode($parameters);

    // Create request
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("x-api-key: " . $apiKey, "Content-type: application/json"));
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $data);

    // Execute request
    $result = curl_exec($curl);

    if (curl_errno($curl) == 0)
    {
      $status_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
      
      if ($status_code == 200)
      {
          $json = json_decode($result, true);
          
          if (!isset($json["error"]) || $json["error"] == false)
          {
              // URL of generated PDF file that will available after the job completion
              $resultFileUrl = $json["url"];
              // Asynchronous job ID
              $jobId = $json["jobId"];
              
              // Check the job status in a loop
              do
              {
                  $status = CheckJobStatus($jobId, $apiKey); // Possible statuses: "working", "failed", "aborted", "success".
                  
                  // Display timestamp and status (for demo purposes)
                  echo "<p>" . date(DATE_RFC2822) . ": " . $status . "</p>";
                  
                  if ($status == "success")
                  {
                      // Display link to the file with conversion results
                      echo "<div><h2>Conversion Result:</h2><a href='" . $resultFileUrl . "' target='_blank'>" . $resultFileUrl . "</a></div>";
                      break;
                  }
                  else if ($status == "working")
                  {
                      // Pause for a few seconds
                      sleep(3);
                  }
                  else 
                  {
                      echo $status . "<br/>";
                      break;
                  }
              }
              while (true);
          }
          else
          {
              // Display service reported error
              echo "<p>Error: " . $json["message"] . "</p>"; 
          }
      }
      else
      {
          // Display request error
          echo "<p>Status code: " . $status_code . "</p>"; 
          echo "<p>" . $result . "</p>"; 
      }
    }
    else
    {
      // Display CURL error
      echo "Error: " . curl_error($curl);
    }

    // Cleanup
    curl_close($curl);


    function CheckJobStatus($jobId, $apiKey)
    {
      $status = null;
      
    // Create URL
      $url = "https://api.pdf.co/v1/job/check";
      
      // Prepare requests params
      $parameters = array();
      $parameters["jobid"] = $jobId;

      // Create Json payload
      $data = json_encode($parameters);

      // Create request
      $curl = curl_init();
      curl_setopt($curl, CURLOPT_HTTPHEADER, array("x-api-key: " . $apiKey, "Content-type: application/json"));
      curl_setopt($curl, CURLOPT_URL, $url);
      curl_setopt($curl, CURLOPT_POST, true);
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
      
      // Execute request
      $result = curl_exec($curl);
      
      if (curl_errno($curl) == 0)
      {
          $status_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
          
          if ($status_code == 200)
          {
              $json = json_decode($result, true);
          
              if (!isset($json["error"]) || $json["error"] == false)
              {
                  $status = $json["status"];
              }
              else
              {
                  // Display service reported error
                  echo "<p>Error: " . $json["message"] . "</p>"; 
              }
          }
          else
          {
              // Display request error
              echo "<p>Status code: " . $status_code . "</p>"; 
              echo "<p>" . $result . "</p>"; 
          }
      }
      else
      {
          // Display CURL error
          echo "Error: " . curl_error($curl);
      }
      
      // Cleanup
      curl_close($curl);
      
      return $status;
    }

    ?>

    </body>
    </html>
    ```
  </Tab>
</Tabs>
